package cn.iocoder.yudao.module.system.service.auth;

import cn.iocoder.yudao.module.system.controller.admin.auth.vo.*;
import cn.iocoder.yudao.module.system.dal.dataobject.user.AdminUserDO;

import javax.validation.Valid;
import java.util.Map;

/**
 * 管理后台的认证 Service 接口
 *
 * 提供用户的登录、登出的能力
 *
 * @author 芋道源码
 */
public interface AdminAuthService {

    /**
     * 验证账号 + 密码。如果通过，则返回用户
     *
     * @param username 账号
     * @param password 密码
     * @return 用户
     */
    AdminUserDO authenticate(String username, String password);
    /**
     * 验证账号 + 密码。如果通过，则返回用户
     *
     * @param username 账号
     * @param password 密码
     * @return 用户
     */
    AdminUserDO authenticateApp(String username, String password,Long tenantId);

    /**
     * 账号登录
     *
     * @param reqVO 登录信息
     * @return 登录结果
     */
    AuthLoginRespVO login(@Valid AuthLoginReqVO reqVO);
    /**
     * 账号登录
     *
     * @param reqVO 登录信息
     * @return 登录结果
     */
    AuthLoginRespVO loginApp(@Valid AuthLoginReqVO reqVO,Long tenantId);

    /**
     * 基于 token 退出登录
     *
     * @param token token
     * @param logType 登出类型
     */
    void logout(String token, Integer logType);

    /**
     * 短信验证码发送
     *
     * @param reqVO 发送请求
     */
    void sendSmsCode(AuthSmsSendReqVO reqVO);

    /**
     * 短信登录
     *
     * @param reqVO 登录信息
     * @return 登录结果
     */
    AuthLoginRespVO smsLogin(AuthSmsLoginReqVO reqVO) ;

    /**
     * 社交快捷登录，使用 code 授权码
     *
     * @param reqVO 登录信息
     * @return 登录结果
     */
    AuthLoginRespVO socialLogin(@Valid AuthSocialLoginReqVO reqVO);

    /**
     * 刷新访问令牌
     *
     * @param refreshToken 刷新令牌
     * @return 登录结果
     */
    AuthLoginRespVO refreshToken(String refreshToken);

    AuthLoginRespVO wxLogin(String decryptResult,String openId,Long inviteId);

    AuthLoginRespVO wxLoginRescue(String decryptResult, String openId, Long inviteId);

    AuthLoginRespVO wxLoginJc(String decryptResult, String openId, Long inviteId);

    /**
     * 根据用户id自动登录
     * @author vinjor-M
     * @date 12:17 2024/9/24
     * @param userId 用户id
 * @param userName 用户名称
     * @return cn.iocoder.yudao.module.system.controller.admin.auth.vo.AuthLoginRespVO
    **/
    AuthLoginRespVO wxLoginByUserId(Long userId,String userName);

    /**
     * 微信小程序自动注册账号并登录
     * @author vinjor-M
     * @date 15:10 2024/9/27
     * @param decryptResult
     * @param openId openId
     * @param inviteId
     * @return cn.iocoder.yudao.module.system.controller.admin.auth.vo.AuthLoginRespVO
    **/
    AuthLoginRespVO wxLoginRepair(String decryptResult, String openId, Long inviteId);

    Map<String, Object> getTenant(AuthLoginReqVO reqVO);
}
